// $ANTLR 2.7.7 (2006-11-01): "CExprAnnotator.g" -> "CExprAnnotator.java"$

// This file is part of the program FRYSK.
//
// Copyright 2007 Red Hat Inc.
//
// FRYSK is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//
// FRYSK is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with FRYSK; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
// 
// In addition, as a special exception, Red Hat, Inc. gives You the
// additional right to link the code of FRYSK with code not covered
// under the GNU General Public License ("Non-GPL Code") and to
// distribute linked combinations including the two, subject to the
// limitations in this paragraph. Non-GPL Code permitted under this
// exception must only link to the code of FRYSK through those well
// defined interfaces identified in the file named EXCEPTION found in
// the source code files (the "Approved Interfaces"). The files of
// Non-GPL Code may instantiate templates or use macros or inline
// functions from the Approved Interfaces without causing the
// resulting work to be covered by the GNU General Public
// License. Only Red Hat, Inc. may make changes or additions to the
// list of Approved Interfaces. You must obey the GNU General Public
// License in all respects for all of the FRYSK code and other code
// used in conjunction with FRYSK except the Non-GPL Code covered by
// this exception. If you modify this file, you may extend this
// exception to your version of the file, but you are not obligated to
// do so. If you do not wish to provide this exception without
// modification, you must delete this exception statement from your
// version and license this file solely under the GPL without
// exception.
    package frysk.expr;

    import java.util.ArrayList;
    // import frysk.value.ArithmeticType;
    // import frysk.value.SignedType;
    // import frysk.value.UnsignedType;
    // import frysk.value.FloatingPointType;
    // import frysk.value.Value;
    import frysk.value.Variable;
    import frysk.expr.ExprSymTab;
    import frysk.expr.ExprAST;
    // import inua.eio.ByteOrder;
    // import lib.dwfl.BaseTypes;

// import antlr.TreeParser;
// import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
// import antlr.ANTLRException;
import antlr.NoViableAltException;
// import antlr.MismatchedTokenException;
// import antlr.SemanticException;
// import antlr.collections.impl.BitSet;
import antlr.ASTPair;
// import antlr.collections.impl.ASTArray;


public class CExprAnnotator extends antlr.TreeParser       implements CExprAnnotatorTokenTypes
 {

    ArrayList      refList;
    private ExprSymTab exprSymTab;
    public CExprAnnotator(ExprSymTab symTab) {
            exprSymTab = symTab;
    }
public CExprAnnotator() {
	tokenNames = _tokenNames;
}

	public final void primitiveType(AST _t) throws RecognitionException {
		
		// ExprAST primitiveType_AST_in = (_t == ASTNULL) ? null : (ExprAST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ExprAST primitiveType_AST = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_boolean:
			{
				ExprAST tmp1_AST = null;
				// ExprAST tmp1_AST_in = null;
				tmp1_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp1_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp1_AST);
				match(_t,LITERAL_boolean);
				_t = _t.getNextSibling();
				primitiveType_AST = (ExprAST)currentAST.root;
				break;
			}
			case LITERAL_char:
			{
				ExprAST tmp2_AST = null;
				// ExprAST tmp2_AST_in = null;
				tmp2_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp2_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp2_AST);
				match(_t,LITERAL_char);
				_t = _t.getNextSibling();
				primitiveType_AST = (ExprAST)currentAST.root;
				break;
			}
			case LITERAL_byte:
			{
				ExprAST tmp3_AST = null;
				// ExprAST tmp3_AST_in = null;
				tmp3_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp3_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp3_AST);
				match(_t,LITERAL_byte);
				_t = _t.getNextSibling();
				primitiveType_AST = (ExprAST)currentAST.root;
				break;
			}
			case LITERAL_short:
			{
				ExprAST tmp4_AST = null;
				// ExprAST tmp4_AST_in = null;
				tmp4_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp4_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp4_AST);
				match(_t,LITERAL_short);
				_t = _t.getNextSibling();
				primitiveType_AST = (ExprAST)currentAST.root;
				break;
			}
			case LITERAL_int:
			{
				ExprAST tmp5_AST = null;
				// ExprAST tmp5_AST_in = null;
				tmp5_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp5_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp5_AST);
				match(_t,LITERAL_int);
				_t = _t.getNextSibling();
				primitiveType_AST = (ExprAST)currentAST.root;
				break;
			}
			case LITERAL_long:
			{
				ExprAST tmp6_AST = null;
				// ExprAST tmp6_AST_in = null;
				tmp6_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp6_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp6_AST);
				match(_t,LITERAL_long);
				_t = _t.getNextSibling();
				primitiveType_AST = (ExprAST)currentAST.root;
				break;
			}
			case LITERAL_float:
			{
				ExprAST tmp7_AST = null;
				// ExprAST tmp7_AST_in = null;
				tmp7_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp7_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp7_AST);
				match(_t,LITERAL_float);
				_t = _t.getNextSibling();
				primitiveType_AST = (ExprAST)currentAST.root;
				break;
			}
			case LITERAL_double:
			{
				ExprAST tmp8_AST = null;
				// ExprAST tmp8_AST_in = null;
				tmp8_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp8_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp8_AST);
				match(_t,LITERAL_double);
				_t = _t.getNextSibling();
				primitiveType_AST = (ExprAST)currentAST.root;
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		returnAST = primitiveType_AST;
		_retTree = _t;
	}
	
	public final void identifier(AST _t) throws RecognitionException {
		
		// ExprAST identifier_AST_in = (_t == ASTNULL) ? null : (ExprAST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ExprAST identifier_AST = null;
		ExprAST ident = null;
		ExprAST ident_AST = null;
		
		try {      // for error handling
			ident = (ExprAST)_t;
			// ExprAST ident_AST_in = null;
			ident_AST = (ExprAST)astFactory.create(ident);
			astFactory.addASTChild(currentAST, ident_AST);
			match(_t,IDENT);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				ident.getText();
			}
			identifier_AST = (ExprAST)currentAST.root;
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		returnAST = identifier_AST;
		_retTree = _t;
	}
	
	public final void expr(AST _t) throws RecognitionException {
		
		// ExprAST expr_AST_in = (_t == ASTNULL) ? null : (ExprAST)_t;
		returnAST = null;
		ASTPair currentAST = new ASTPair();
		ExprAST expr_AST = null;
		ExprAST o = null;
		ExprAST o_AST = null;
		ExprAST i = null;
		ExprAST i_AST = null;
		ExprAST h = null;
		ExprAST h_AST = null;
		ExprAST f = null;
		ExprAST f_AST = null;
		ExprAST d = null;
		ExprAST d_AST = null;
		// ExprAST pt_AST = null;
		ExprAST pt = null;
		ExprAST ident = null;
		ExprAST ident_AST = null;
		ExprAST tident = null;
		ExprAST tident_AST = null;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case PLUS:
			{
				AST __t4 = _t;
				ExprAST tmp9_AST = null;
				// ExprAST tmp9_AST_in = null;
				tmp9_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp9_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp9_AST);
				ASTPair __currentAST4 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,PLUS);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST4;
				_t = __t4;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case STAR:
			{
				AST __t13 = _t;
				ExprAST tmp10_AST = null;
				// ExprAST tmp10_AST_in = null;
				tmp10_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp10_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp10_AST);
				ASTPair __currentAST13 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,STAR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST13;
				_t = __t13;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case MEMORY:
			{
				AST __t14 = _t;
				ExprAST tmp11_AST = null;
				// ExprAST tmp11_AST_in = null;
				tmp11_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp11_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp11_AST);
				ASTPair __currentAST14 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,MEMORY);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST14;
				_t = __t14;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case DIVIDE:
			{
				AST __t15 = _t;
				ExprAST tmp12_AST = null;
				// ExprAST tmp12_AST_in = null;
				tmp12_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp12_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp12_AST);
				ASTPair __currentAST15 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,DIVIDE);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST15;
				_t = __t15;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case MOD:
			{
				AST __t16 = _t;
				ExprAST tmp13_AST = null;
				// ExprAST tmp13_AST_in = null;
				tmp13_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp13_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp13_AST);
				ASTPair __currentAST16 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,MOD);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST16;
				_t = __t16;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case SHIFTLEFT:
			{
				AST __t17 = _t;
				ExprAST tmp14_AST = null;
				// ExprAST tmp14_AST_in = null;
				tmp14_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp14_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp14_AST);
				ASTPair __currentAST17 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,SHIFTLEFT);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST17;
				_t = __t17;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case SHIFTRIGHT:
			{
				AST __t18 = _t;
				ExprAST tmp15_AST = null;
				// ExprAST tmp15_AST_in = null;
				tmp15_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp15_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp15_AST);
				ASTPair __currentAST18 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,SHIFTRIGHT);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST18;
				_t = __t18;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case LESSTHAN:
			{
				AST __t19 = _t;
				ExprAST tmp16_AST = null;
				// ExprAST tmp16_AST_in = null;
				tmp16_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp16_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp16_AST);
				ASTPair __currentAST19 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,LESSTHAN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST19;
				_t = __t19;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case GREATERTHAN:
			{
				AST __t20 = _t;
				ExprAST tmp17_AST = null;
				// ExprAST tmp17_AST_in = null;
				tmp17_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp17_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp17_AST);
				ASTPair __currentAST20 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,GREATERTHAN);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST20;
				_t = __t20;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case LESSTHANOREQUALTO:
			{
				AST __t21 = _t;
				ExprAST tmp18_AST = null;
				// ExprAST tmp18_AST_in = null;
				tmp18_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp18_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp18_AST);
				ASTPair __currentAST21 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,LESSTHANOREQUALTO);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST21;
				_t = __t21;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case GREATERTHANOREQUALTO:
			{
				AST __t22 = _t;
				ExprAST tmp19_AST = null;
				// ExprAST tmp19_AST_in = null;
				tmp19_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp19_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp19_AST);
				ASTPair __currentAST22 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,GREATERTHANOREQUALTO);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST22;
				_t = __t22;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case NOTEQUAL:
			{
				AST __t23 = _t;
				ExprAST tmp20_AST = null;
				// ExprAST tmp20_AST_in = null;
				tmp20_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp20_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp20_AST);
				ASTPair __currentAST23 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,NOTEQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST23;
				_t = __t23;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case EQUAL:
			{
				AST __t24 = _t;
				ExprAST tmp21_AST = null;
				// ExprAST tmp21_AST_in = null;
				tmp21_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp21_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp21_AST);
				ASTPair __currentAST24 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,EQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST24;
				_t = __t24;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case AMPERSAND:
			{
				AST __t28 = _t;
				ExprAST tmp22_AST = null;
				// ExprAST tmp22_AST_in = null;
				tmp22_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp22_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp22_AST);
				ASTPair __currentAST28 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,AMPERSAND);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST28;
				_t = __t28;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case ADDRESS_OF:
			{
				AST __t29 = _t;
				ExprAST tmp23_AST = null;
				// ExprAST tmp23_AST_in = null;
				tmp23_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp23_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp23_AST);
				ASTPair __currentAST29 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,ADDRESS_OF);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST29;
				_t = __t29;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case BITWISEXOR:
			{
				AST __t30 = _t;
				ExprAST tmp24_AST = null;
				// ExprAST tmp24_AST_in = null;
				tmp24_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp24_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp24_AST);
				ASTPair __currentAST30 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,BITWISEXOR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST30;
				_t = __t30;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case BITWISEOR:
			{
				AST __t31 = _t;
				ExprAST tmp25_AST = null;
				// ExprAST tmp25_AST_in = null;
				tmp25_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp25_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp25_AST);
				ASTPair __currentAST31 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,BITWISEOR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST31;
				_t = __t31;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case AND:
			{
				AST __t32 = _t;
				ExprAST tmp26_AST = null;
				// ExprAST tmp26_AST_in = null;
				tmp26_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp26_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp26_AST);
				ASTPair __currentAST32 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,AND);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST32;
				_t = __t32;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case OR:
			{
				AST __t33 = _t;
				ExprAST tmp27_AST = null;
				// ExprAST tmp27_AST_in = null;
				tmp27_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp27_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp27_AST);
				ASTPair __currentAST33 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,OR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST33;
				_t = __t33;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case NOT:
			{
				AST __t34 = _t;
				ExprAST tmp28_AST = null;
				// ExprAST tmp28_AST_in = null;
				tmp28_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp28_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp28_AST);
				ASTPair __currentAST34 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,NOT);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST34;
				_t = __t34;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case TILDE:
			{
				AST __t35 = _t;
				ExprAST tmp29_AST = null;
				// ExprAST tmp29_AST_in = null;
				tmp29_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp29_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp29_AST);
				ASTPair __currentAST35 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,TILDE);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST35;
				_t = __t35;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case COND_EXPR:
			{
				AST __t36 = _t;
				ExprAST tmp30_AST = null;
				// ExprAST tmp30_AST_in = null;
				tmp30_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp30_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp30_AST);
				ASTPair __currentAST36 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,COND_EXPR);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST36;
				_t = __t36;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case OCTALINT:
			{
				o = (ExprAST)_t;
				// ExprAST o_AST_in = null;
				o_AST = (ExprAST)astFactory.create(o);
				astFactory.addASTChild(currentAST, o_AST);
				match(_t,OCTALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case DECIMALINT:
			{
				i = (ExprAST)_t;
				// ExprAST i_AST_in = null;
				i_AST = (ExprAST)astFactory.create(i);
				astFactory.addASTChild(currentAST, i_AST);
				match(_t,DECIMALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case HEXADECIMALINT:
			{
				h = (ExprAST)_t;
				// ExprAST h_AST_in = null;
				h_AST = (ExprAST)astFactory.create(h);
				astFactory.addASTChild(currentAST, h_AST);
				match(_t,HEXADECIMALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case FLOAT:
			{
				f = (ExprAST)_t;
				// ExprAST f_AST_in = null;
				f_AST = (ExprAST)astFactory.create(f);
				astFactory.addASTChild(currentAST, f_AST);
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case DOUBLE:
			{
				d = (ExprAST)_t;
				// ExprAST d_AST_in = null;
				d_AST = (ExprAST)astFactory.create(d);
				astFactory.addASTChild(currentAST, d_AST);
				match(_t,DOUBLE);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case ASSIGNEQUAL:
			{
				AST __t37 = _t;
				ExprAST tmp31_AST = null;
				// ExprAST tmp31_AST_in = null;
				tmp31_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp31_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp31_AST);
				ASTPair __currentAST37 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,ASSIGNEQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST37;
				_t = __t37;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case TIMESEQUAL:
			{
				AST __t38 = _t;
				ExprAST tmp32_AST = null;
				// ExprAST tmp32_AST_in = null;
				tmp32_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp32_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp32_AST);
				ASTPair __currentAST38 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,TIMESEQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST38;
				_t = __t38;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case DIVIDEEQUAL:
			{
				AST __t39 = _t;
				ExprAST tmp33_AST = null;
				// ExprAST tmp33_AST_in = null;
				tmp33_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp33_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp33_AST);
				ASTPair __currentAST39 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,DIVIDEEQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST39;
				_t = __t39;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case MINUSEQUAL:
			{
				AST __t40 = _t;
				ExprAST tmp34_AST = null;
				// ExprAST tmp34_AST_in = null;
				tmp34_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp34_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp34_AST);
				ASTPair __currentAST40 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,MINUSEQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST40;
				_t = __t40;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case PLUSEQUAL:
			{
				AST __t41 = _t;
				ExprAST tmp35_AST = null;
				// ExprAST tmp35_AST_in = null;
				tmp35_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp35_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp35_AST);
				ASTPair __currentAST41 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,PLUSEQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST41;
				_t = __t41;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case MODEQUAL:
			{
				AST __t42 = _t;
				ExprAST tmp36_AST = null;
				// ExprAST tmp36_AST_in = null;
				tmp36_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp36_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp36_AST);
				ASTPair __currentAST42 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,MODEQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST42;
				_t = __t42;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case SHIFTLEFTEQUAL:
			{
				AST __t43 = _t;
				ExprAST tmp37_AST = null;
				// ExprAST tmp37_AST_in = null;
				tmp37_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp37_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp37_AST);
				ASTPair __currentAST43 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,SHIFTLEFTEQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST43;
				_t = __t43;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case SHIFTRIGHTEQUAL:
			{
				AST __t44 = _t;
				ExprAST tmp38_AST = null;
				// ExprAST tmp38_AST_in = null;
				tmp38_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp38_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp38_AST);
				ASTPair __currentAST44 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,SHIFTRIGHTEQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST44;
				_t = __t44;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case BITWISEANDEQUAL:
			{
				AST __t45 = _t;
				ExprAST tmp39_AST = null;
				// ExprAST tmp39_AST_in = null;
				tmp39_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp39_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp39_AST);
				ASTPair __currentAST45 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,BITWISEANDEQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST45;
				_t = __t45;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case BITWISEXOREQUAL:
			{
				AST __t46 = _t;
				ExprAST tmp40_AST = null;
				// ExprAST tmp40_AST_in = null;
				tmp40_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp40_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp40_AST);
				ASTPair __currentAST46 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,BITWISEXOREQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST46;
				_t = __t46;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case BITWISEOREQUAL:
			{
				AST __t47 = _t;
				ExprAST tmp41_AST = null;
				// ExprAST tmp41_AST_in = null;
				tmp41_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp41_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp41_AST);
				ASTPair __currentAST47 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,BITWISEOREQUAL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST47;
				_t = __t47;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case CAST:
			{
				AST __t48 = _t;
				ExprAST tmp42_AST = null;
				// ExprAST tmp42_AST_in = null;
				tmp42_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp42_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp42_AST);
				ASTPair __currentAST48 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,CAST);
				_t = _t.getFirstChild();
				pt = _t==ASTNULL ? null : (ExprAST)_t;
				primitiveType(_t);
				_t = _retTree;
//				pt_AST = (ExprAST)returnAST;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST48;
				_t = __t48;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    if(pt.getText().compareTo("long") == 0) {
						      }
						    else if(pt.getText().compareTo("int") == 0) {
						      }
						    else if(pt.getText().compareTo("short") == 0) {
						      }
						    else if(pt.getText().compareTo("double") == 0) {
						      }
						    else if(pt.getText().compareTo("float") == 0) {
						      }
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case EXPR_LIST:
			{
				AST __t49 = _t;
				ExprAST tmp43_AST = null;
				// ExprAST tmp43_AST_in = null;
				tmp43_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp43_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp43_AST);
				ASTPair __currentAST49 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,EXPR_LIST);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST49;
				_t = __t49;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case FUNC_CALL:
			{
				AST __t50 = _t;
				ExprAST tmp44_AST = null;
				// ExprAST tmp44_AST_in = null;
				tmp44_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp44_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp44_AST);
				ASTPair __currentAST50 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,FUNC_CALL);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST50;
				_t = __t50;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case MEMBER:
			{
				AST __t51 = _t;
				ExprAST tmp45_AST = null;
				// ExprAST tmp45_AST_in = null;
				tmp45_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp45_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp45_AST);
				ASTPair __currentAST51 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,MEMBER);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				identifier(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST51;
				_t = __t51;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case POINTERTO:
			{
				AST __t52 = _t;
				ExprAST tmp46_AST = null;
				// ExprAST tmp46_AST_in = null;
				tmp46_AST = (ExprAST)astFactory.create((ExprAST)_t);
//				tmp46_AST_in = (ExprAST)_t;
				astFactory.addASTChild(currentAST, tmp46_AST);
				ASTPair __currentAST52 = currentAST.copy();
				currentAST.root = currentAST.child;
				currentAST.child = null;
				match(_t,POINTERTO);
				_t = _t.getFirstChild();
				expr(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				identifier(_t);
				_t = _retTree;
				astFactory.addASTChild(currentAST, returnAST);
				currentAST = __currentAST52;
				_t = __t52;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case IDENT:
			{
				ident = (ExprAST)_t;
				// ExprAST ident_AST_in = null;
				ident_AST = (ExprAST)astFactory.create(ident);
				astFactory.addASTChild(currentAST, ident_AST);
				match(_t,IDENT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					Variable var;
					var = exprSymTab.getVariable(ident.getText());
					ident.exprType = exprSymTab.getType(var);
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			case TAB_IDENT:
			{
				tident = (ExprAST)_t;
				// ExprAST tident_AST_in = null;
				tident_AST = (ExprAST)astFactory.create(tident);
				astFactory.addASTChild(currentAST, tident_AST);
				match(_t,TAB_IDENT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					Variable var;
					var = exprSymTab.getVariable(tident.getText());
					tident.exprType = exprSymTab.getType(var);
					
				}
				expr_AST = (ExprAST)currentAST.root;
				break;
			}
			default:
				boolean synPredMatched7 = false;
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==MINUS))) {
					AST __t7 = _t;
					synPredMatched7 = true;
					inputState.guessing++;
					try {
						{
						AST __t6 = _t;
						ASTPair __currentAST6 = currentAST.copy();
						currentAST.root = currentAST.child;
						currentAST.child = null;
						match(_t,MINUS);
						_t = _t.getFirstChild();
						expr(_t);
						_t = _retTree;
						expr(_t);
						_t = _retTree;
						currentAST = __currentAST6;
						_t = __t6;
						_t = _t.getNextSibling();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched7 = false;
					}
					_t = __t7;
inputState.guessing--;
				}
				if ( synPredMatched7 ) {
					AST __t8 = _t;
					ExprAST tmp47_AST = null;
					// ExprAST tmp47_AST_in = null;
					tmp47_AST = (ExprAST)astFactory.create((ExprAST)_t);
//					tmp47_AST_in = (ExprAST)_t;
					astFactory.addASTChild(currentAST, tmp47_AST);
					ASTPair __currentAST8 = currentAST.copy();
					currentAST.root = currentAST.child;
					currentAST.child = null;
					match(_t,MINUS);
					_t = _t.getFirstChild();
					expr(_t);
					_t = _retTree;
					astFactory.addASTChild(currentAST, returnAST);
					expr(_t);
					_t = _retTree;
					astFactory.addASTChild(currentAST, returnAST);
					currentAST = __currentAST8;
					_t = __t8;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						
						
					}
					expr_AST = (ExprAST)currentAST.root;
				}
				else if ((_t.getType()==MINUS)) {
					AST __t9 = _t;
					ExprAST tmp48_AST = null;
					// ExprAST tmp48_AST_in = null;
					tmp48_AST = (ExprAST)astFactory.create((ExprAST)_t);
//					tmp48_AST_in = (ExprAST)_t;
					astFactory.addASTChild(currentAST, tmp48_AST);
					ASTPair __currentAST9 = currentAST.copy();
					currentAST.root = currentAST.child;
					currentAST.child = null;
					match(_t,MINUS);
					_t = _t.getFirstChild();
					expr(_t);
					_t = _retTree;
					astFactory.addASTChild(currentAST, returnAST);
					currentAST = __currentAST9;
					_t = __t9;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						
						
					}
					expr_AST = (ExprAST)currentAST.root;
				}
			else {
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		returnAST = expr_AST;
		_retTree = _t;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"ADDRESS_OF",
		"ARG_LIST",
		"CAST",
		"REFERENCE",
		"SUBSCRIPT",
		"COND_EXPR",
		"EXPR_LIST",
		"FUNC_CALL",
		"MEMORY",
		"MEMBER",
		"ETX",
		"COMMA",
		"ASSIGNEQUAL",
		"TIMESEQUAL",
		"DIVIDEEQUAL",
		"MINUSEQUAL",
		"PLUSEQUAL",
		"MODEQUAL",
		"SHIFTLEFTEQUAL",
		"SHIFTRIGHTEQUAL",
		"BITWISEANDEQUAL",
		"BITWISEXOREQUAL",
		"BITWISEOREQUAL",
		"SEMICOLON",
		"RPAREN",
		"QUESTIONMARK",
		"COLON",
		"OR",
		"AND",
		"BITWISEOR",
		"BITWISEXOR",
		"AMPERSAND",
		"NOTEQUAL",
		"EQUAL",
		"LESSTHAN",
		"GREATERTHAN",
		"LESSTHANOREQUALTO",
		"GREATERTHANOREQUALTO",
		"SHIFTLEFT",
		"SHIFTRIGHT",
		"PLUS",
		"MINUS",
		"STAR",
		"DIVIDE",
		"MOD",
		"PLUSPLUS",
		"MINUSMINUS",
		"TILDE",
		"NOT",
		"\"boolean\"",
		"\"char\"",
		"\"byte\"",
		"\"short\"",
		"\"int\"",
		"\"long\"",
		"\"float\"",
		"\"double\"",
		"LPAREN",
		"TAB",
		"\"this\"",
		"LSQUARE",
		"RSQUARE",
		"DOT",
		"POINTERTO",
		"OCTALINT",
		"DECIMALINT",
		"HEXADECIMALINT",
		"CharLiteral",
		"StringLiteral",
		"FLOAT",
		"DOUBLE",
		"\"true\"",
		"\"false\"",
		"IDENT",
		"TAB_IDENT",
		"\"operator\"",
		"AT",
		"LCURLY",
		"RCURLY",
		"SCOPE",
		"ELLIPSIS",
		"NL",
		"WS",
		"Escape",
		"Digit",
		"Decimal",
		"LongSuffix",
		"UnsignedSuffix",
		"FloatSuffix",
		"Exponent",
		"Vocabulary",
		"NUM",
		"HEX_DIGIT",
		"EXPONENT",
		"FLOAT_SUFFIX"
	};
	
	}
	
