// $ANTLR 2.7.7 (2006-11-01): "CExprEvaluator.g" -> "CExprEvaluator.java"$

// This file is part of the program FRYSK.
//
// Copyright 2005, 2007 Red Hat Inc.
//
// FRYSK is free software; you can redistribute it and/or modify it
// under the terms of the GNU General Public License as published by
// the Free Software Foundation; version 2 of the License.
//
// FRYSK is distributed in the hope that it will be useful, but
// WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
// General Public License for more details.
// 
// You should have received a copy of the GNU General Public License
// along with FRYSK; if not, write to the Free Software Foundation,
// Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA.
// 
// In addition, as a special exception, Red Hat, Inc. gives You the
// additional right to link the code of FRYSK with code not covered
// under the GNU General Public License ("Non-GPL Code") and to
// distribute linked combinations including the two, subject to the
// limitations in this paragraph. Non-GPL Code permitted under this
// exception must only link to the code of FRYSK through those well
// defined interfaces identified in the file named EXCEPTION found in
// the source code files (the "Approved Interfaces"). The files of
// Non-GPL Code may instantiate templates or use macros or inline
// functions from the Approved Interfaces without causing the
// resulting work to be covered by the GNU General Public
// License. Only Red Hat, Inc. may make changes or additions to the
// list of Approved Interfaces. You must obey the GNU General Public
// License in all respects for all of the FRYSK code and other code
// used in conjunction with FRYSK except the Non-GPL Code covered by
// this exception. If you modify this file, you may extend this
// exception to your version of the file, but you are not obligated to
// do so. If you do not wish to provide this exception without
// modification, you must delete this exception statement from your
// version and license this file solely under the GPL without
// exception.
    package frysk.expr;

    import java.util.ArrayList;
    import frysk.value.ArithmeticType;
    import frysk.value.SignedType;
    // import frysk.value.UnsignedType;
    import frysk.value.FloatingPointType;
    import frysk.value.Value;
    import frysk.expr.ExprSymTab;
    import frysk.expr.ExprAST;
    import inua.eio.ByteOrder;
    // import lib.dwfl.BaseTypes;

// import antlr.TreeParser;
// import antlr.Token;
import antlr.collections.AST;
import antlr.RecognitionException;
// import antlr.ANTLRException;
import antlr.NoViableAltException;
// import antlr.MismatchedTokenException;
// import antlr.SemanticException;
// import antlr.collections.impl.BitSet;
// import antlr.ASTPair;
// import antlr.collections.impl.ASTArray;


public class CExprEvaluator extends antlr.TreeParser       implements CExprEvaluatorTokenTypes
 {

    ArrayList      refList;
    ArithmeticType arithmeticType;
    ArithmeticType longType;
    ArithmeticType intType;
    ArithmeticType shortType;
    FloatingPointType doubleType;
    FloatingPointType floatType;
    private ExprSymTab exprSymTab;
    public CExprEvaluator(ExprSymTab symTab) {
	    exprSymTab = symTab;
        // FIXME: The ExprSymTab can provide types such as this.
        shortType = new SignedType("short", ByteOrder.LITTLE_ENDIAN, 2);
        intType = new SignedType("int", ByteOrder.LITTLE_ENDIAN, 4);
        longType = new SignedType("long", ByteOrder.LITTLE_ENDIAN, 8);
        floatType = new FloatingPointType("false", ByteOrder.LITTLE_ENDIAN, 4);
        doubleType = new FloatingPointType("double", ByteOrder.LITTLE_ENDIAN, 8);
    }
public CExprEvaluator() {
	tokenNames = _tokenNames;
}

	public final void primitiveType(AST _t) throws RecognitionException {
		
		// ExprAST primitiveType_AST_in = (_t == ASTNULL) ? null : (ExprAST)_t;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case LITERAL_boolean:
			{
				// ExprAST tmp1_AST_in = (ExprAST)_t;
				match(_t,LITERAL_boolean);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_char:
			{
				// ExprAST tmp2_AST_in = (ExprAST)_t;
				match(_t,LITERAL_char);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_byte:
			{
				// ExprAST tmp3_AST_in = (ExprAST)_t;
				match(_t,LITERAL_byte);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_short:
			{
				// ExprAST tmp4_AST_in = (ExprAST)_t;
				match(_t,LITERAL_short);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_int:
			{
				// ExprAST tmp5_AST_in = (ExprAST)_t;
				match(_t,LITERAL_int);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_long:
			{
				// ExprAST tmp6_AST_in = (ExprAST)_t;
				match(_t,LITERAL_long);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_float:
			{
				// ExprAST tmp7_AST_in = (ExprAST)_t;
				match(_t,LITERAL_float);
				_t = _t.getNextSibling();
				break;
			}
			case LITERAL_double:
			{
				// ExprAST tmp8_AST_in = (ExprAST)_t;
				match(_t,LITERAL_double);
				_t = _t.getNextSibling();
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final String  identifier(AST _t) throws RecognitionException {
		String idSpelling=null;
		
		// ExprAST identifier_AST_in = (_t == ASTNULL) ? null : (ExprAST)_t;
		ExprAST ident = null;
		
		try {      // for error handling
			ident = (ExprAST)_t;
			match(_t,IDENT);
			_t = _t.getNextSibling();
			if ( inputState.guessing==0 ) {
				idSpelling=ident.getText();
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
		return idSpelling;
	}
	
	public final ArrayList  references(AST _t) throws RecognitionException {
		ArrayList el = null; // ;
		
		// ExprAST references_AST_in = (_t == ASTNULL) ? null : (ExprAST)_t;
		refList = new ArrayList();
		
		try {      // for error handling
			{
			_loop5:
			do {
				if (_t==null) _t=ASTNULL;
				if ((_t.getType()==SUBSCRIPT||_t.getType()==IDENT)) {
					subscript_or_member(_t);
					_t = _retTree;
				}
				else {
					break _loop5;
				}
				
			} while (true);
			}
			if ( inputState.guessing==0 ) {
				el=refList;
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
		return el;
	}
	
	public final void subscript_or_member(AST _t) throws RecognitionException {
		
		// ExprAST subscript_or_member_AST_in = (_t == ASTNULL) ? null : (ExprAST)_t;
		Value s; String id;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case SUBSCRIPT:
			{
				AST __t7 = _t;
				// ExprAST tmp9_AST_in = (ExprAST)_t;
				match(_t,SUBSCRIPT);
				_t = _t.getFirstChild();
				s=expr(_t);
				_t = _retTree;
				_t = __t7;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					refList.add(new Integer((int)s.asLong()).toString());
				}
				break;
			}
			case IDENT:
			{
				id=identifier(_t);
				_t = _retTree;
				if ( inputState.guessing==0 ) {
					refList.add(id);
				}
				break;
			}
			default:
			{
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
	}
	
	public final Value  expr(AST _t) throws RecognitionException {
		Value returnVar=null;
		
		// ExprAST expr_AST_in = (_t == ASTNULL) ? null : (ExprAST)_t;
		ExprAST o = null;
		ExprAST i = null;
		ExprAST h = null;
		ExprAST f = null;
		ExprAST d = null;
		ExprAST pt = null;
		ExprAST ident = null;
		ExprAST tident = null;
		Value v1, v2, log_expr; String s1; ArrayList el;
		
		try {      // for error handling
			if (_t==null) _t=ASTNULL;
			switch ( _t.getType()) {
			case PLUS:
			{
				AST __t9 = _t;
				// ExprAST tmp10_AST_in = (ExprAST)_t;
				match(_t,PLUS);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t9;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
						
							    returnVar = v1.getType().add(v1, v2);  
					
				}
				break;
			}
			case STAR:
			{
				AST __t18 = _t;
				// ExprAST tmp11_AST_in = (ExprAST)_t;
				match(_t,STAR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t18;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().multiply(v1, v2); 
					
				}
				break;
			}
			case MEMORY:
			{
				AST __t19 = _t;
				// ExprAST tmp12_AST_in = (ExprAST)_t;
				match(_t,MEMORY);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t19;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().dereference(v1, exprSymTab.taskMemory());
					
				}
				break;
			}
			case DIVIDE:
			{
				AST __t20 = _t;
				// ExprAST tmp13_AST_in = (ExprAST)_t;
				match(_t,DIVIDE);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t20;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().divide(v1, v2); 
					
				}
				break;
			}
			case MOD:
			{
				AST __t21 = _t;
				// ExprAST tmp14_AST_in = (ExprAST)_t;
				match(_t,MOD);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t21;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().mod(v1, v2);  
					
				}
				break;
			}
			case SHIFTLEFT:
			{
				AST __t22 = _t;
				// ExprAST tmp15_AST_in = (ExprAST)_t;
				match(_t,SHIFTLEFT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t22;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().shiftLeft(v1, v2);  
					
				}
				break;
			}
			case SHIFTRIGHT:
			{
				AST __t23 = _t;
				// ExprAST tmp16_AST_in = (ExprAST)_t;
				match(_t,SHIFTRIGHT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t23;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().shiftRight(v1, v2); 
					
				}
				break;
			}
			case LESSTHAN:
			{
				AST __t24 = _t;
				// ExprAST tmp17_AST_in = (ExprAST)_t;
				match(_t,LESSTHAN);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t24;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().lessThan(v1, v2); 
					
				}
				break;
			}
			case GREATERTHAN:
			{
				AST __t25 = _t;
				// ExprAST tmp18_AST_in = (ExprAST)_t;
				match(_t,GREATERTHAN);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t25;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().greaterThan(v1, v2); 
					
				}
				break;
			}
			case LESSTHANOREQUALTO:
			{
				AST __t26 = _t;
				// ExprAST tmp19_AST_in = (ExprAST)_t;
				match(_t,LESSTHANOREQUALTO);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t26;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().lessThanOrEqualTo(v1, v2); 
					
				}
				break;
			}
			case GREATERTHANOREQUALTO:
			{
				AST __t27 = _t;
				// ExprAST tmp20_AST_in = (ExprAST)_t;
				match(_t,GREATERTHANOREQUALTO);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t27;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().greaterThanOrEqualTo(v1, v2); 
					
				}
				break;
			}
			case NOTEQUAL:
			{
				AST __t28 = _t;
				// ExprAST tmp21_AST_in = (ExprAST)_t;
				match(_t,NOTEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t28;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().notEqual(v1, v2); 
					
				}
				break;
			}
			case EQUAL:
			{
				AST __t29 = _t;
				// ExprAST tmp22_AST_in = (ExprAST)_t;
				match(_t,EQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t29;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().equal(v1, v2); 
					
				}
				break;
			}
			case AMPERSAND:
			{
				AST __t33 = _t;
				// ExprAST tmp23_AST_in = (ExprAST)_t;
				match(_t,AMPERSAND);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t33;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().bitWiseAnd(v1, v2); 
					
				}
				break;
			}
			case ADDRESS_OF:
			{
				AST __t34 = _t;
				// ExprAST tmp24_AST_in = (ExprAST)_t;
				match(_t,ADDRESS_OF);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t34;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().addressOf(v1, exprSymTab.order());
					
				}
				break;
			}
			case BITWISEXOR:
			{
				AST __t35 = _t;
				// ExprAST tmp25_AST_in = (ExprAST)_t;
				match(_t,BITWISEXOR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t35;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().bitWiseXor(v1, v2); 
					
				}
				break;
			}
			case BITWISEOR:
			{
				AST __t36 = _t;
				// ExprAST tmp26_AST_in = (ExprAST)_t;
				match(_t,BITWISEOR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t36;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().bitWiseOr(v1, v2); 
					
				}
				break;
			}
			case AND:
			{
				AST __t37 = _t;
				// ExprAST tmp27_AST_in = (ExprAST)_t;
				match(_t,AND);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t37;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().logicalAnd(v1, v2); 
					
				}
				break;
			}
			case OR:
			{
				AST __t38 = _t;
				// ExprAST tmp28_AST_in = (ExprAST)_t;
				match(_t,OR);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t38;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().logicalOr(v1, v2); 
					
				}
				break;
			}
			case NOT:
			{
				AST __t39 = _t;
				// ExprAST tmp29_AST_in = (ExprAST)_t;
				match(_t,NOT);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t39;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().logicalNegation(v1); 
					
				}
				break;
			}
			case TILDE:
			{
				AST __t40 = _t;
				// ExprAST tmp30_AST_in = (ExprAST)_t;
				match(_t,TILDE);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t40;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().bitWiseComplement(v1); 
					
				}
				break;
			}
			case COND_EXPR:
			{
				AST __t41 = _t;
				// ExprAST tmp31_AST_in = (ExprAST)_t;
				match(_t,COND_EXPR);
				_t = _t.getFirstChild();
				log_expr=expr(_t);
				_t = _retTree;
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t41;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((log_expr.getType().getLogicalValue(log_expr)) ? v1 : v2);
					
				}
				break;
			}
			case OCTALINT:
			{
				o = (ExprAST)_t;
				match(_t,OCTALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = o.getText().charAt(o.getText().length() - 1);
						    int l = o.getText().length();
						    if (c == 'u' || c == 'U' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar =
					longType.createValue(Long.parseLong(o.getText().substring(1, l), 8));
					
				}
				break;
			}
			case DECIMALINT:
			{
				i = (ExprAST)_t;
				match(_t,DECIMALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = i.getText().charAt(i.getText().length() - 1);
						    int l = i.getText().length();
						    if (c == 'u' || c == 'U' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar =
					longType.createValue(Long.parseLong(i.getText().substring(0, l)));
					
				}
				break;
			}
			case HEXADECIMALINT:
			{
				h = (ExprAST)_t;
				match(_t,HEXADECIMALINT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = h.getText().charAt(h.getText().length() - 1);
						    int l = h.getText().length();
						    if (c == 'u' || c == 'U' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar =
					longType.createValue(Long.parseLong(h.getText().substring(2, l), 16));
					
				}
				break;
			}
			case FLOAT:
			{
				f = (ExprAST)_t;
				match(_t,FLOAT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = f.getText().charAt(f.getText().length() - 1);
						    int l = f.getText().length();
						    if (c == 'f' || c == 'F' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar =
					floatType.createValue(Float.parseFloat(f.getText().substring(0, l)));
					
				}
				break;
			}
			case DOUBLE:
			{
				d = (ExprAST)_t;
				match(_t,DOUBLE);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    char c = d.getText().charAt(d.getText().length() - 1);
						    int l = d.getText().length();
						    if (c == 'f' || c == 'F' || c == 'l' || c == 'L')
						       l -= 1;
					returnVar =
					doubleType.createValue(Double.parseDouble(d.getText().substring(0, l)));
					
				}
				break;
			}
			case ASSIGNEQUAL:
			{
				AST __t42 = _t;
				// ExprAST tmp32_AST_in = (ExprAST)_t;
				match(_t,ASSIGNEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t42;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.assign(v2);
					returnVar = v1;
					
				}
				break;
			}
			case TIMESEQUAL:
			{
				AST __t43 = _t;
				// ExprAST tmp33_AST_in = (ExprAST)_t;
				match(_t,TIMESEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t43;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.getType().timesEqual(v1, v2);
					returnVar = v1;
					
				}
				break;
			}
			case DIVIDEEQUAL:
			{
				AST __t44 = _t;
				// ExprAST tmp34_AST_in = (ExprAST)_t;
				match(_t,DIVIDEEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t44;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.getType().divideEqual(v1, v2);
					returnVar = v1;
					
				}
				break;
			}
			case MINUSEQUAL:
			{
				AST __t45 = _t;
				// ExprAST tmp35_AST_in = (ExprAST)_t;
				match(_t,MINUSEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t45;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.getType().minusEqual(v1, v2);
					returnVar = v1;
					
				}
				break;
			}
			case PLUSEQUAL:
			{
				AST __t46 = _t;
				// ExprAST tmp36_AST_in = (ExprAST)_t;
				match(_t,PLUSEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t46;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.getType().plusEqual(v1, v2);
					returnVar = v1;
					
				}
				break;
			}
			case MODEQUAL:
			{
				AST __t47 = _t;
				// ExprAST tmp37_AST_in = (ExprAST)_t;
				match(_t,MODEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t47;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.getType().modEqual(v1, v2);
					returnVar = v1;
					
				}
				break;
			}
			case SHIFTLEFTEQUAL:
			{
				AST __t48 = _t;
				// ExprAST tmp38_AST_in = (ExprAST)_t;
				match(_t,SHIFTLEFTEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t48;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.getType().shiftLeftEqual(v1, v2);
					returnVar = v1;
					
				}
				break;
			}
			case SHIFTRIGHTEQUAL:
			{
				AST __t49 = _t;
				// ExprAST tmp39_AST_in = (ExprAST)_t;
				match(_t,SHIFTRIGHTEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t49;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.getType().shiftRightEqual(v1, v2);
					returnVar = v1;
					
				}
				break;
			}
			case BITWISEANDEQUAL:
			{
				AST __t50 = _t;
				// ExprAST tmp40_AST_in = (ExprAST)_t;
				match(_t,BITWISEANDEQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t50;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.getType().bitWiseAndEqual(v1, v2);
					returnVar = v1;
					
				}
				break;
			}
			case BITWISEXOREQUAL:
			{
				AST __t51 = _t;
				// ExprAST tmp41_AST_in = (ExprAST)_t;
				match(_t,BITWISEXOREQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t51;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.getType().bitWiseXorEqual(v1, v2);
					returnVar = v1;
					
				}
				break;
			}
			case BITWISEOREQUAL:
			{
				AST __t52 = _t;
				// ExprAST tmp42_AST_in = (ExprAST)_t;
				match(_t,BITWISEOREQUAL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t52;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					v1.getType().bitWiseOrEqual(v1, v2);
					returnVar = v1;
					
				}
				break;
			}
			case CAST:
			{
				AST __t53 = _t;
				// ExprAST tmp43_AST_in = (ExprAST)_t;
				match(_t,CAST);
				_t = _t.getFirstChild();
				pt = _t==ASTNULL ? null : (ExprAST)_t;
				primitiveType(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t53;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
						    if(pt.getText().compareTo("long") == 0) {
						      returnVar = longType.createValue(0);
					returnVar.assign(v2);
						      }
						    else if(pt.getText().compareTo("int") == 0) {
						      returnVar = intType.createValue(0);
					returnVar.assign(v2);
						      }
						    else if(pt.getText().compareTo("short") == 0) {
						      returnVar = shortType.createValue(0);
					returnVar.assign(v2);
						      }
						    else if(pt.getText().compareTo("double") == 0) {
						      returnVar = doubleType.createValue(0.0);
					returnVar.assign(v2);
						      }
						    else if(pt.getText().compareTo("float") == 0) {
						      returnVar = floatType.createValue(0.0);
					returnVar.assign(v2);
						      }
						    else returnVar = v2;
					
				}
				break;
			}
			case EXPR_LIST:
			{
				AST __t54 = _t;
				// ExprAST tmp44_AST_in = (ExprAST)_t;
				match(_t,EXPR_LIST);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				_t = __t54;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1;
					
				}
				break;
			}
			case FUNC_CALL:
			{
				AST __t55 = _t;
				// ExprAST tmp45_AST_in = (ExprAST)_t;
				match(_t,FUNC_CALL);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				v2=expr(_t);
				_t = _retTree;
				_t = __t55;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1;
					
				}
				break;
			}
			case MEMBER:
			{
				AST __t56 = _t;
				// ExprAST tmp46_AST_in = (ExprAST)_t;
				match(_t,MEMBER);
				_t = _t.getFirstChild();
				v1=expr(_t);
				_t = _retTree;
				s1=identifier(_t);
				_t = _retTree;
				_t = __t56;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = v1.getType().member(v1, s1);
					
				}
				break;
			}
			case REFERENCE:
			{
				AST __t57 = _t;
				// ExprAST tmp47_AST_in = (ExprAST)_t;
				match(_t,REFERENCE);
				_t = _t.getFirstChild();
				el=references(_t);
				_t = _retTree;
				_t = __t57;
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = (Value)exprSymTab.getValueFIXME(el);
					
				}
				break;
			}
			case IDENT:
			{
				ident = (ExprAST)_t;
				match(_t,IDENT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((Value)exprSymTab.getValue(ident.getText()));
					
				}
				break;
			}
			case TAB_IDENT:
			{
				tident = (ExprAST)_t;
				match(_t,TAB_IDENT);
				_t = _t.getNextSibling();
				if ( inputState.guessing==0 ) {
					
					returnVar = ((Value)exprSymTab.getValue(tident.getText()));
					
				}
				break;
			}
			default:
				boolean synPredMatched12 = false;
				if (_t==null) _t=ASTNULL;
				if (((_t.getType()==MINUS))) {
					AST __t12 = _t;
					synPredMatched12 = true;
					inputState.guessing++;
					try {
						{
						AST __t11 = _t;
						// ExprAST tmp48_AST_in = (ExprAST)_t;
						match(_t,MINUS);
						_t = _t.getFirstChild();
						expr(_t);
						_t = _retTree;
						expr(_t);
						_t = _retTree;
						_t = __t11;
						_t = _t.getNextSibling();
						}
					}
					catch (RecognitionException pe) {
						synPredMatched12 = false;
					}
					_t = __t12;
inputState.guessing--;
				}
				if ( synPredMatched12 ) {
					AST __t13 = _t;
					// ExprAST tmp49_AST_in = (ExprAST)_t;
					match(_t,MINUS);
					_t = _t.getFirstChild();
					v1=expr(_t);
					_t = _retTree;
					v2=expr(_t);
					_t = _retTree;
					_t = __t13;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						
						returnVar = v1.getType().subtract(v1, v2);  
						
					}
				}
				else if ((_t.getType()==MINUS)) {
					AST __t14 = _t;
					// ExprAST tmp50_AST_in = (ExprAST)_t;
					match(_t,MINUS);
					_t = _t.getFirstChild();
					v1=expr(_t);
					_t = _retTree;
					_t = __t14;
					_t = _t.getNextSibling();
					if ( inputState.guessing==0 ) {
						
						returnVar = intType.createValue(0);
						returnVar = returnVar.getType().subtract(returnVar, v1); 
						
					}
				}
			else {
				throw new NoViableAltException(_t);
			}
			}
		}
		catch (RecognitionException ex) {
			if (inputState.guessing==0) {
				reportError(ex);
				if (_t!=null) {_t = _t.getNextSibling();}
			} else {
			  throw ex;
			}
		}
		_retTree = _t;
		return returnVar;
	}
	
	
	public static final String[] _tokenNames = {
		"<0>",
		"EOF",
		"<2>",
		"NULL_TREE_LOOKAHEAD",
		"ADDRESS_OF",
		"ARG_LIST",
		"CAST",
		"REFERENCE",
		"SUBSCRIPT",
		"COND_EXPR",
		"EXPR_LIST",
		"FUNC_CALL",
		"MEMORY",
		"MEMBER",
		"ETX",
		"COMMA",
		"ASSIGNEQUAL",
		"TIMESEQUAL",
		"DIVIDEEQUAL",
		"MINUSEQUAL",
		"PLUSEQUAL",
		"MODEQUAL",
		"SHIFTLEFTEQUAL",
		"SHIFTRIGHTEQUAL",
		"BITWISEANDEQUAL",
		"BITWISEXOREQUAL",
		"BITWISEOREQUAL",
		"SEMICOLON",
		"RPAREN",
		"QUESTIONMARK",
		"COLON",
		"OR",
		"AND",
		"BITWISEOR",
		"BITWISEXOR",
		"AMPERSAND",
		"NOTEQUAL",
		"EQUAL",
		"LESSTHAN",
		"GREATERTHAN",
		"LESSTHANOREQUALTO",
		"GREATERTHANOREQUALTO",
		"SHIFTLEFT",
		"SHIFTRIGHT",
		"PLUS",
		"MINUS",
		"STAR",
		"DIVIDE",
		"MOD",
		"PLUSPLUS",
		"MINUSMINUS",
		"TILDE",
		"NOT",
		"\"boolean\"",
		"\"char\"",
		"\"byte\"",
		"\"short\"",
		"\"int\"",
		"\"long\"",
		"\"float\"",
		"\"double\"",
		"LPAREN",
		"TAB",
		"\"this\"",
		"LSQUARE",
		"RSQUARE",
		"DOT",
		"POINTERTO",
		"OCTALINT",
		"DECIMALINT",
		"HEXADECIMALINT",
		"CharLiteral",
		"StringLiteral",
		"FLOAT",
		"DOUBLE",
		"\"true\"",
		"\"false\"",
		"IDENT",
		"TAB_IDENT",
		"\"operator\"",
		"AT",
		"LCURLY",
		"RCURLY",
		"SCOPE",
		"ELLIPSIS",
		"NL",
		"WS",
		"Escape",
		"Digit",
		"Decimal",
		"LongSuffix",
		"UnsignedSuffix",
		"FloatSuffix",
		"Exponent",
		"Vocabulary",
		"NUM",
		"HEX_DIGIT",
		"EXPONENT",
		"FLOAT_SUFFIX"
	};
	
	}
	
